=== debian/changelog ===
gmt (6.0.0+dfsg-1build2) focal; urgency=medium

  * No-change upload for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:07:58 +0100

gmt (6.0.0+dfsg-1build1) focal; urgency=medium

  * No-change rebuild for gdal soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jan 2020 14:30:35 +0000

gmt (6.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Install upstream manpages.
  * Refresh patches.
  * Strip pre-releases from symbols version.
  * Drop unused override for sphinxdoc-but-no-sphinxdoc-depends.
  * Update symbols for 6.0.0.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Nov 2019 21:15:10 +0100

gmt (6.0.0~rc5+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Bump Standards-Version to 4.4.1, no changes.
  * Update copyright file.
  * Refresh patches.
  * Update lintian override for manpages, no longer provided by upstream.
  * Update symbols for 6.0.0~rc5.
  * Repack upstream tarball to exclude rst sources.
  * Drop gmt-docs package.
  * Drop obsolete dh_installman override.
  * Drop gmt-examples package.
  * Add lintian override for file-references-package-build-path.
  * Include supplements in gmt-common package.
  * Add lintian override for sphinxdoc-but-no-sphinxdoc-depends.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 24 Oct 2019 09:54:15 +0200

gmt (6.0.0~rc4+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Drop python-sphinx from build dependencies.
  * Update symbols for 6.0.0~rc4.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 07 Sep 2019 08:35:33 +0200
